/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 *  strict-local
 * @format
 */

'use strict';

/**
 * @internal
 *
 * A map from developer-friendly operation names ("append", "prepend", "remove")
 * to internal book-keeping keys used to store metadata on records
 * ("__rangeOperationAppend__" etc).
 */
var rangeOperationToMetadataKey = {};
rangeOperationToMetadataKey[require('relay-runtime').RangeOperations.APPEND] = '__rangeOperationAppend__';
rangeOperationToMetadataKey[require('relay-runtime').RangeOperations.IGNORE] = '__rangeOperationIgnore__';
rangeOperationToMetadataKey[require('relay-runtime').RangeOperations.PREPEND] = '__rangeOperationPrepend__';
rangeOperationToMetadataKey[require('relay-runtime').RangeOperations.REFETCH] = '__rangeOperationRefetch__';
rangeOperationToMetadataKey[require('relay-runtime').RangeOperations.REMOVE] = '__rangeOperationRemove__';

module.exports = Object.freeze(rangeOperationToMetadataKey);